"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseResponse = exports.response = exports.description = exports.params = exports.url = exports.identifier = exports.fromSection = exports.isEndpointSection = exports.fromDocument = void 0;
const Cheerio = __importStar(require("cheerio"));
const F = __importStar(require("fp-ts/function"));
const Common = __importStar(require("./common"));
const O = __importStar(require("fp-ts/Option"));
const marked_1 = __importDefault(require("marked"));
const Structures = __importStar(require("./structures"));
const Arr = __importStar(require("fp-ts/Array"));
const fromDocument = (markdown, file) => markdown
    .replace(/\r\n/, "\n")
    .split(/(^|\n)##\s+/)
    .map((section) => section.split("\n"))
    .filter(exports.isEndpointSection)
    .map((0, exports.fromSection)(file));
exports.fromDocument = fromDocument;
const endpointR = /(.*) % (get|post|put|patch|delete) (.*)$/i;
const isEndpointSection = (section) => endpointR.test(section[0]);
exports.isEndpointSection = isEndpointSection;
const fromSection = (file) => (section) => {
    const markdown = `## ${section.join("\n")}`;
    const $ = Cheerio.load((0, marked_1.default)(markdown));
    const match = section[0].match(endpointR);
    const route = (0, exports.identifier)(file)(match[1]);
    return {
        route,
        description: (0, exports.description)($),
        method: match[2],
        url: (0, exports.url)(match[3]),
        params: (0, exports.params)(file, $, markdown, route, !/get|delete/i.test(match[2])),
        response: (0, exports.response)($, section.join(" "), route),
    };
};
exports.fromSection = fromSection;
const identifier = (file) => (heading) => F.pipe(heading.trim(), Common.camelify, Common.maybeRename(file));
exports.identifier = identifier;
const url = (raw) => raw.replace(/\{(.*?)\}/g, F.flow((_, param) => param.split("#")[0].replace(/[^A-z]/g, "_"), (param) => `{${param}}`));
exports.url = url;
const params = (file, $, markdown, route, hasBody) => {
    const takes = F.pipe(O.fromNullable(/\bTakes a.*?\./.exec(markdown)), O.alt(() => O.fromNullable(/\bBody is.*?\./.exec(markdown))), O.map((matches) => ({ match: matches[0] })), O.bind("$", ({ match }) => O.some(Cheerio.load((0, marked_1.default)(match)))), O.bind("array", ({ match }) => O.some(/array|list/.test(match))), O.chain(({ $, array }) => F.pipe(Structures.referenceFromLinks("")($("a")), O.map((identifier) => ({
        identifier,
        array,
        structures: [],
    })))));
    return F.pipe(Structures.fromDocument($, {
        exclude: /zzz/,
        include: /params/i,
    }), Arr.filter(({ identifier }) => hasBody ? !/querystring/i.test(identifier) : !/json/i.test(identifier)), Arr.map((structure) => {
        const identifier = Common.typeify(route);
        const variant = structure.identifier
            .replace(/json/i, "")
            .replace(/form/i, "")
            .replace(/querystring/i, "")
            .replace(/Params?/, "");
        return {
            ...structure,
            identifier: Common.maybeRename(file)(`${identifier}${variant}Params`),
        };
    }), O.fromPredicate((s) => s.length > 0), O.map((structures) => ({
        identifier: Common.maybeRename(file)(`${Common.typeify(route)}Params`),
        array: false,
        structures,
    })), O.alt(() => takes));
};
exports.params = params;
const description = ($) => F.pipe(O.some($("h2").next("p").first()), O.filter(($p) => $p.length > 0), O.map(($p) => $p.text().trim()));
exports.description = description;
const response = ($, markdown, route) => {
    const returns = F.pipe(O.fromNullable(markdown.match(/\b(returns|responses? includes?|body is an?) .*?\./gi)), O.map((m) => m.join(" ")), O.chain(exports.parseResponse));
    const alias = F.pipe(O.fromNullable(markdown.match(/\bfunctions the same as .*?\./gi)), O.map((m) => m[0]), O.map((_) => Cheerio.load((0, marked_1.default)(_))), O.chain(($) => F.pipe(Structures.referenceFromLinks("")($("a")), O.map((_) => ({
        identifier: (0, exports.identifier)("")(_),
        array: false,
        structures: [],
        alias: true,
    })))));
    return F.pipe(Structures.fromDocument($, { exclude: /zzz/, include: /response/i }), Arr.map((structure) => {
        const identifier = Common.typeify(route);
        return {
            ...structure,
            identifier: `${identifier}Response`,
        };
    }), O.fromPredicate((s) => s.length > 0), O.map((structures) => ({
        identifier: `${Common.typeify(route)}Response`,
        array: false,
        structures,
    })), O.alt(() => returns), O.alt(() => alias));
};
exports.response = response;
const parseResponse = (markdown) => {
    const $ = Cheerio.load((0, marked_1.default)(markdown));
    const identifier = Structures.referenceFromLinks("")($("a"));
    const array = /array|list/.test(markdown);
    return F.pipe(identifier, O.map((identifier) => ({
        identifier,
        array,
        structures: [],
    })));
};
exports.parseResponse = parseResponse;
