"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.identifierOrReference = exports.referenceFromLink = exports.referencesFromLinks = exports.referenceFromLinks = exports.type = exports.field = exports.fields = exports.identifier = exports.fromHeader = exports.fromDocument = exports.excludeR = void 0;
const F = __importStar(require("fp-ts/function"));
const Arr = __importStar(require("fp-ts/Array"));
const O = __importStar(require("fp-ts/Option"));
const R = __importStar(require("remeda"));
const Common = __importStar(require("./common"));
const Enums = __importStar(require("./enums"));
const isStructureTable = ($) => ($table) => {
    const $th = $table.find("th");
    const headers = $th.map((_, th) => $(th).text().trim()).toArray();
    const field = headers.some((text) => /field|name/i.test(text));
    const type = headers.some((text) => /type|value/i.test(text));
    const description = headers.some((text) => /description/i.test(text));
    return field && type && description;
};
exports.excludeR = /(%|example|json|type|change key|flag|modes?$|styles)/i;
const headerSelectors = ["h2", "h6", "#client-status-object"];
const fromDocument = ($, { file = "", exclude = exports.excludeR, include = /.*/, }) => $(headerSelectors.join(", "))
    .toArray()
    .map((h6) => [
    $(h6),
    Common.table($(h6)),
])
    .filter(([_$h6, $table]) => isStructureTable($)($table))
    .filter(([$h6, _]) => !exclude.test($h6.text()))
    .filter(([$h6, _]) => include.test($h6.text()))
    .map(([$h6, $table]) => (0, exports.fromHeader)($, file)($h6, $table));
exports.fromDocument = fromDocument;
const fromHeader = ($, file) => ($h6, $table) => ({
    identifier: (0, exports.identifier)(file, true)($h6.text()),
    fields: (0, exports.fields)($, file)($table),
});
exports.fromHeader = fromHeader;
const identifier = (file, isHeading = false) => (heading) => F.pipe(heading
    .replace(/(\s+|-)fields/i, "")
    .replace(/(\s+|-)object/i, "")
    .replace(/(\s+|-)structure$/i, "")
    .replace(/optional/i, "")
    .trim(), Common.typeify, Common.maybeRename(file, isHeading));
exports.identifier = identifier;
const fields = ($, file) => ($table) => {
    const headerCount = $table.find("th").length;
    return F.pipe($table
        .find("td")
        .map((_, td) => $(td))
        .toArray(), R.chunk(headerCount), R.map((fields) => (0, exports.field)(file)(fields[0], fields[1], fields[2])));
};
exports.fields = fields;
const field = (file) => ($name, $type, $description) => {
    const name = $name.text().replace(/\*/g, "").trim();
    const identifier = name.replace(/\?/g, "").match(/^[A-Za-z_$]+/)[0];
    const optional = /\?$/.test(name);
    return {
        name: identifier,
        optional,
        type: (0, exports.type)(file)($type, $description),
        description: $description.text(),
    };
};
exports.field = field;
const type = (file) => ($type, $description) => {
    const text = $type.text();
    const nullable = text.startsWith("?");
    const rawIdentifier = sanitizeIdentifier(file)(text);
    const array = rawIdentifier === "array" || /array|list/i.test(text);
    const relation = (0, exports.referenceFromLinks)(file)($type.find("a"));
    const snowflakeMap = /map of snowflakes/i.test(text);
    return {
        identifier: (0, exports.identifierOrReference)(file)(rawIdentifier, relation, $description),
        nullable,
        array,
        snowflakeMap,
    };
};
exports.type = type;
const sanitizeIdentifier = (file) => (text) => F.pipe(O.some(text), 
// Snowflake?
O.filter((text) => /\b(snowflake|object id)/.test(text)), O.map(() => "snowflake"), 
// Array of
O.alt(() => F.pipe(O.fromNullable(text.match(/^(?:array|list) of (\w*)$/)), O.map((matches) => matches[1]), O.map(sanitizeIdentifier(file)))), 
// String?
O.alt(() => F.pipe(O.fromNullable(text.match(/\bstrings?\b/)), O.map(() => "string"))), 
// Timestamp?
O.alt(() => F.pipe(O.fromNullable(text.match(/timestamp\b/)), O.map(() => "timestamp"))), 
// Normalize ints
O.alt(() => F.pipe(O.fromNullable(text.match(/\bint/)), O.map(() => "integer"))), O.alt(() => F.pipe(O.fromNullable(text.match(/\bfloat/i)), O.map(() => "float"))), 
// Boolean
O.alt(() => F.pipe(O.fromNullable(text.match(/\bbool(ean)?\b/)), O.map(() => "boolean"))), O.alt(() => F.pipe(O.fromNullable(text.match(/array|list|component object/)), O.map(() => "array"))), O.alt(() => F.pipe(O.fromNullable(text.match(/dict/)), O.map(() => "dict"))), O.alt(() => F.pipe(O.fromNullable(text.match(/null/)), O.map(() => "null"))), 
// Mixed
O.alt(() => F.pipe(O.fromNullable(text.match(/mixed|\bOptionType\b|application command option type/)), O.map(() => "mixed"))), 
// Normal identifier
O.getOrElse(() => F.pipe(text.replace(/[^A-z]/g, ""), Common.typeify, Common.maybeRename(file))));
const referenceFromLinks = (file) => ($links, includeStructures = true) => F.pipe(O.some($links), 
// Get the first link's href
O.filter(($links) => $links.length > 0), O.map(($links) => $links.first()), O.chain(($link) => (0, exports.referenceFromLink)(file)($link, includeStructures)));
exports.referenceFromLinks = referenceFromLinks;
const referencesFromLinks = ($, file) => ($links, includeStructures = true) => $links
    .toArray()
    .map((link) => $(link))
    .map(($link) => (0, exports.referenceFromLink)(file)($link, includeStructures))
    .filter(O.isSome)
    .map((ref) => ref.value);
exports.referencesFromLinks = referencesFromLinks;
const referenceFromLink = (file) => ($link, includeStructures = true) => F.pipe(O.some($link), O.chainNullableK(($link) => $link.attr("href")), O.filter((href) => !/wikipedia/.test(href)), O.chain(F.flow((href) => href.split("/"), Arr.last, O.filter((s) => s.length > 0))), O.chain(referenceFromSegment(file, includeStructures)));
exports.referenceFromLink = referenceFromLink;
const referenceFromSegment = (file, includeStructures) => (ref) => F.pipe(
// Structures
O.some(ref), O.filter(() => includeStructures), O.filter((ref) => !exports.excludeR.test(ref)), O.map((ref) => ref.replace(/^poll-results-object-/, "")), O.map((ref) => ref.replace(/-object-structure$/, "")), O.map((ref) => ref.replace(/^.*-object-/, "")), 
// Misc clean up
O.map((ref) => ref.replace(/^data-models-/, "")), O.map((ref) => ref.replace(/^shared-resources-/, "")), O.map((ref) => ref.replace(/identify-identify/, "identify")), O.map((0, exports.identifier)(file)), 
// Enum
O.alt(() => F.pipe(O.some(ref), O.filter((ref) => Enums.enumSuffixR.test(ref)), O.map((ref) => ref.replace(/^.*-object-/, "")), O.map((ref) => ref.replace(/^data-models-/, "")), O.map((ref) => ref.replace(/^shared-resources-/, "")), O.map((ref) => ref.replace(/^update-status-/, "")), O.map((ref) => ref.replace(/^buttons-/, "")), O.map(Enums.identifier(file)))), 
// Objects
O.alt(() => F.pipe(O.some(ref), O.filter(() => includeStructures), O.filter((ref) => /-object$/.test(ref)), O.map((ref) => ref.replace(/^data-models-/, "")), O.map((ref) => ref.replace(/-object$/, "")), O.map(Common.typeify), O.map(Common.maybeRename(file)))), 
// Everything else
O.alt(() => F.pipe(O.some(ref), O.filter(() => includeStructures), O.map(Common.typeify), O.map(Common.maybeRename(file)))));
const identifierOrReference = (file) => (identifier, relation, $description) => F.pipe(
// Only use relation if it isn't a snowflake or mixed
O.some(identifier), O.filter((id) => !["snowflake", "mixed"].includes(id)), O.chain(() => relation), 
// Maybe use reference for arrays or objects
O.alt(() => F.pipe(O.some(identifier), O.filter((id) => /array|mixed/.test(id)), O.chain(() => (0, exports.referenceFromLinks)(file)($description.find("a"))))), 
// Maybe use reference for enumerable types
O.alt(() => F.pipe(O.some(identifier), O.filter((id) => ["string", "integer"].includes(id)), O.chain(() => (0, exports.referenceFromLinks)(file)($description.find("a"), false)))), O.getOrElse(() => identifier.replace(/arrayof/, "")));
exports.identifierOrReference = identifierOrReference;
